; intellect.lsp


;(load "jcpplisp.lsp")

(setq *max-key-number* 0)

(defun intellect ()
    (let ((brain (make-hash-table)) (word))
	(princ "Intellect version1.02 Ｓ＆Ｓ") (terpri)
	(load-data brain)
	(set-max-key-number brain)
	(princ "終了するにはbyeと入力") (terpri)
	(loop
;(princ *max-key-number*) (prin1 brain) (terpri)
	    (princ "日本語で単語を入力して下さい:")
	    (setq word (read-line-need))
	    (if (string-equal word "bye") (return))
	    (main word brain)
        )
	(princ "保存しますか(y/n)")
	(if (eql (read) 'y) (save-data brain))
    )
)

(defun read-line-need ()
    (let ((a))
	(loop
	    (setq a (read-line))
	    (if (not (string-equal a "")) (return a)) ) ) )

(defun save-data (brain)
    (let ((f (open "intellectdata.txt" :direction :output)))
	(if (null f) (progn (princ "ファイルを開けません") (terpri))
	    (progn
		(princ "保存中．．．") (terpri)
		(maphash
		    #'(lambda (key v)
			(print `(,key ,v) f) ) brain)
		(close f)
		(princ "保存しました") (terpri) ) ) ) )

(defun set-max-key-number (brain)
    (maphash #'(lambda (x y) (if (< *max-key-number* x) (setq *max-key-number* x))) brain) )

(defun load-data (brain)
    (let ((one) (f (open "intellectdata.txt")))
	(if (null f) (progn (princ "ファイルを開けません") (terpri))
	    (progn
		(princ "読み込み中．．．") (terpri)
		(loop
	    	    (if (eql (setq one (read f nil t)) t) (return))
;(print one)
	    	    (setf (gethash (car one) brain) (cadr one)) )
		(close f)
		(princ "読み込みました") (terpri) ) ) ) )

;(defun question (word brain)
;    (prog (shape color)
;	(princ word) (princ "の形は？") (setq shape (read-line)) (if (string-equal shape "bye") (return))
;	(princ word) (princ "の色は？") (setq color (read-line)) (if (string-equal color "bye") (return))
;	(setf (gethash (setq *max-key-number* (1+ *max-key-number*)) brain)
;			(cons (cons "名前" (cons word nil)) `(("形は" ,shape) ("色は" ,color))))
;    )
;)

(defun get-three-number (k)
    (let ((ans) (n))
	(loop
	    (if (= (length ans) 3) (return ans))
	    (setq n (random k))
	    (if (not (member n ans)) (setq ans (cons n ans))) ) ) )

(defun question (word brain)
    (let ((jos) (ns) (n) (jo) (johas) (ha) (kepns))
	(setq jos '("形は" "色は" "味は" "落とすと" "食べると" "こすると"
			"投げると" "切ると" "曲げると" "触ると" "押すと" "回すと") )
	(setq ns (get-three-number (length jos)))
	(setq kepns ns)
	(setq ret
	  (loop
	    (if (null ns) (return nil))
	    (setq n (car ns))
	    (setq jo (nth n jos))
	    (princ word) (princ "は") (princ jo) (princ "?") (setq ha (read-line-need)) (if (string-equal ha "bye") (return t))
	    (setq ns (cdr ns))
	    (setq johas (cons `(,jo ,ha) johas))
	    (setq johas (coffee johas word brain (make-three-number kepns jos))) ) )
	(if (not ret) (setf (gethash (setq *max-key-number* (1+ *max-key-number*)) brain)
		(cons `("名前" ,word) johas) ) ) ) )

(defun make-three-number (ns jos)
    (let ((ans))
	(loop
	    (if (null ns) (return))
	    (setq ans (cons (nth (car ns) jos) ans))
	    (setq ns (cdr ns)) )
	ans ) )

(defun coffee (johas word brain subjos)
    (let ((ans) (kep johas) (z) (a) (flag johas) (once nil))
	(maphash #'(lambda (x y)
	    (setq johas kep)
	    (loop
		(if (null johas) (return))
		(setq z (assoc-string (caar johas) y))
		(if (and (not once) z (string-equal (caar johas) (car z)) (string-equal (cadar johas) (cadr z)))
			(progn
			    (setq once t)
			    (setq a (nth (random (length y)) y))
			    (if (or (string-equal (car a) "名前") (assoc-string (car a) kep) (member (car a) subjos :test #'string-equal))
				(setq flag kep)
				(progn
				    (princ word) (princ "は") (princ (car a)) (princ (cadr a)) (princ "、ですか？(y/n)")
				    (if (eql (read) 'y)
					(setq flag (cons a kep))
					(setq flag kep) ) )
			    ) ) )
		(setq johas (cdr johas)) ) )
	    brain )
	flag ) )

(defun main (word brain)
    (if (exist-word word brain) (name-info) (question word brain))
)

(defun name-info ()
    (let ((temp *mem*) (name))
	(setq name (assoc-string "名前" temp))
	(if (not (null name)) (setq name (cadr name)))
	(loop
	    (if (null temp) (return))
	    (if (not (string-equal (caar temp) "名前"))
		(progn (princ name) (princ "は") (princ (caar temp))
			(princ (cadar temp)) (princ "、です。") (terpri) ) )
	    (setq temp (cdr temp)) ) ) )

(defun exist-word (word brain)
    (setq *flag* nil)
    (maphash
	#'(lambda (x y)
	    (let ((a y))
		(loop
		    (if (null a) (return))
	            (if (and (string-equal (caar a) "名前") (string-equal (cadar a) word))
			(progn (setq *mem* y) (setq *flag* x) (return)) )
		    (setq a (cdr a)) ) ) )
	brain )
    (if *flag* t nil) )

(defun assoc-string (x alist)
    (cond
	((atom alist) nil)
	((string-equal x (car (car alist))) (car alist))
	(t (assoc-string x (cdr alist))) ) )

(intellect)
