; ジャンケンゲーム

(defun janken ()
    (let ((ch))
	(princ "ジャンケンゲーム") (terpri)
	(loop
	    (princ "キーを入力して下さい(g,c,p,q,h,hはヘルプです):")
	    (setq ch (read))
	    (cond
		((or (eql ch 'g) (eql ch 'c) (eql ch 'p)) (fight ch))
		((eql ch 'h) (help))
		((eql ch 'q) (return t))))))

(defun help ()
    (princ "ジャンケンゲーム ヘルプ") (terpri)
    (princ "h : ヘルプ") (terpri)
    (princ "q : 終了") (terpri)
    (princ "g : グー") (terpri)
    (princ "c : チョキ") (terpri)
    (princ "p : パー") (terpri) (terpri)
)

(defun fight (you)
    (let ((computer) (you-win))
	(setq computer (go-computer))
	(show-info you computer)
	(setq you-win (did-you-win you computer))
	(show-result you-win)))

(defun go-computer ()
    (let ((n))
	(setq n (random 3))
	(cond
	    ((eql n 0) 'g)
	    ((eql n 1) 'c)
	    (t 'p))))

(defun show-info (you computer)
    (princ "あなた:") (janken-name you) (princ " ") (princ "コンピュータ:") (janken-name computer) (terpri))

(defun janken-name (ch)
    (cond
	((eql ch 'g) (princ "グー！"))
	((eql ch 'c) (princ "チョキ！"))
	((eql ch 'p) (princ "パー！"))))

(defun did-you-win (you computer)
    (cond
	((eql you computer) 'e)
	((and (eql you 'g) (eql computer 'c)) 'w)
	((and (eql you 'g) (eql computer 'p)) 'l)
	((and (eql you 'c) (eql computer 'g)) 'l)
	((and (eql you 'c) (eql computer 'p)) 'w)
	((and (eql you 'p) (eql computer 'g)) 'w)
	((and (eql you 'p) (eql computer 'c)) 'l)))

(setq *you* 0)

(setq *computer* 0)

(defun show-result (ch)
    (let ()
	(cond
	    ((eql ch 'e) (princ "引き分け！") (terpri))
	    ((eql ch 'w) (setq *you* (1+ *you*)) (princ "あなたの勝ち！") (terpri))
	    ((eql ch 'l) (setq *computer* (1+ *computer*)) (princ "コンピュータの勝ち！") (terpri)))
	(show-win-rate) (terpri)))

(defun show-win-rate ()
    (let ((r))
	(princ "（あなた:") (prin1 *you*) (princ " ")
	(if (and (= *you* 0) (= *computer* 0)) (princ "0%）")
	    (progn (prin1 (setq r (floor (/ (* 100 *you*) (+ *you* *computer* 0.0))))) (princ "%）")))
	(terpri)
	(princ "（コンピュータ:") (prin1 *computer*) (princ " ")
	(if (and (= *you* 0) (= *computer* 0)) (princ "0%）")
	    (progn (prin1 (- 100 r)) (princ "%）")))
	(terpri)))

(janken)

