// linux.cpp

#include "jcpplisp.h"

extern CELL *TCell,*NILCell,*CHARACTER,*TINTERNAL;

CELL *cfunction::char_to_code(CELL *p,SYMVAL *loc,long locn,long lock)
{
    CELL *q,*r,*s;
    AINT *i;

    if (p->attr != 'l') goto serror;
    s = p->car;
    IncCellStack(NULL);
    IncCellStack(p);
    q = eval(s,loc,locn,lock);
    PopCellStack();
    if (q == NULL) return NULL;
    if (q->attr != 'm') goto serror;
    i = (AINT *)getInt(((unsigned long)(q->car)) & 0xff);
    r = getCell();
    r->attr = 'i';
    r->car = (CELL *)i;
    r->cdr = NULL;
    return r;

 serror:
    printf("エラー: CHAR-CODEの使い方が間違っています。\n");
    errorlisp(loc,locn);
    return NULL;
}

CELL *cfunction::code_to_char(CELL *p,SYMVAL *loc,long locn,long lock)
{
    CELL *q,*r,*s;
    long c;

    if (p->attr != 'l') goto serror;
    s = p->car;
    IncCellStack(NULL);
    IncCellStack(p);
    q = eval(s,loc,locn,lock);
    PopCellStack();
    if (q == NULL) return NULL;
    if (q->attr != 'i') goto serror;
    c = (((AINT *)(q->car))->f);
    if (c < 0) goto serror;
    c &= 0xff;
    r = getCell();
    r->attr = 'm';
    r->car = (CELL *)c;
    r->cdr = NULL;
    return r;

 serror:
    printf("エラー: CODE-CHARの使い方が間違っています。\n");
    errorlisp(loc,locn);
    return NULL;
}

CELL *cfunction::symbolname(CELL *p,SYMVAL *loc,long locn)
{
    char s[1024];
    char *u;

    if (p->attr != 'l') {
	puts("引数が足りません");
	errorlisp(loc,locn);
	return NULL;
    }
    //IncCellStack(NULL);
    //IncCellStack(p);
    p = eval(p->car,loc,locn,0);
    //PopCellStack();
    if (p == NULL) return NULL;
    if (p->attr != 's') {
	puts("シンボルではありません");
	errorlisp(loc,locn);
	return NULL;
    }
    u = (char *)(p->car);
    if (*u == ':') u++;
    strcpy(s + 1,u);
    *s = '"';
    strcat(s,"\"");
    return getMojiretsuCell(s);
}

CELL *cfunction::t_intern(CELL *p,SYMVAL *loc,long locn)
{
    char s[1024];
    char *u;
    CELL *q,*r,*r2;
    BOOL flag;

    if (p->attr != 'l') {
	puts("引数が足りません");
	errorlisp(loc,locn);
	return NULL;
    }
    p = eval(p->car,loc,locn,0);
    if (p == NULL) return NULL;
    if (p->attr == 'a' && (p->car)->attr == 'i' &&
	 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
	GetStringC(p->cdr->cdr,s);
	u = s;
	while (*u != '\0') {
	    if (islower(*u)) {
		puts("エラー: INTERNは現在のところ小文字を含む文字列には対応していません");
		errorlisp(loc,locn);
		return NULL;
	    }
	    if (*u == ' ' || *u == '@' || *u == ',' || *u == '\'' || *u == ';' || *u == ':' || *u == '\"') {
		puts("エラー: INTERNは現在のところその文字を含む文字列には対応していません");
		errorlisp(loc,locn);
		return NULL;
	    }
	    if (isKanji((unsigned char *)u)) u += 2;
	    else u++;
	}
	if (strlen(s) == 0) {
	    puts("エラー: INTERNは現在のところ空文字列には対応していません");
	    errorlisp(loc,locn);
	    return NULL;
	}
	if (CheckStringCell(s) == NULL) flag = TRUE;
	else flag = FALSE;
	q = getStringCell(s);
	r = getCell();
	r2 = getCell();
	r->attr = 'l';
	r->car = q;
	r->cdr = r2;
	r2->attr = 'l';
	if (flag) r2->car = NILCell;
	else r2->car = TINTERNAL;
	r2->cdr = NILCell;
	q->mtop = r;
	return q;
    }
    puts("文字列ではありません");
    errorlisp(loc,locn);
    return NULL;
}

CELL *cfunction::t_intern_wide(CELL *p,SYMVAL *loc,long locn)
{
    char s[1024];
    char *u;
    CELL *q,*r,*r2;
    BOOL flag;

    if (p->attr != 'l') {
	puts("引数が足りません");
	errorlisp(loc,locn);
	return NULL;
    }
    p = eval(p->car,loc,locn,0);
    if (p == NULL) return NULL;
    if (p->attr == 'a' && (p->car)->attr == 'i' &&
	 ((AINT *)((p->car)->car))->f == 1 && (p->cdr)->car == CHARACTER) {
	GetStringC(p->cdr->cdr,s);
	u = s;
	while (*u != '\0') {
	    if (islower(*u)) {
		puts("エラー: INTERN-WIDEは現在のところ小文字を含む文字列には対応していません");
		errorlisp(loc,locn);
		return NULL;
	    }
	    if (*u == ' ' || *u == '@' || *u == ',' || *u == '\'' || *u == ';' || *u == ':' || *u == '\"') {
		puts("エラー: INTERN-WIDEは現在のところその文字を含む文字列には対応していません");
		errorlisp(loc,locn);
		return NULL;
	    }
	    if (isKanji((unsigned char *)u)) u += 2;
	    else u++;
	}
	if (strlen(s) == 0) {
	    puts("エラー: INTERN-WIDEは現在のところ空文字列には対応していません");
	    errorlisp(loc,locn);
	    return NULL;
	}
	flag = TRUE;
	q = getStringCellWide(s);
	r = getCell();
	r2 = getCell();
	r->attr = 'l';
	r->car = q;
	r->cdr = r2;
	r2->attr = 'l';
	if (flag) r2->car = NILCell;
	else r2->car = TINTERNAL;
	r2->cdr = NILCell;
	q->mtop = r;
	return q;
    }
    puts("文字列ではありません");
    errorlisp(loc,locn);
    return NULL;
}

void cprint::GetStringC(CELL *a,char *s)  // a = (#\h #\e #\l #\l #\o) etc.
{
    for (;;) {
	if (jnlength(a) == 0) break;
	if (a->attr != 'l') { *s = '\0'; return; }
	if ((a->car)->attr != 'm') { *s = '\0'; return; }
	if ((a->car)->cdr == NULL) {
	    //fprintf(fp,"%c",(unsigned char)(long)((a->car)->car));
	    *s++ = (unsigned char)(long)((a->car)->car);
	}
	else {
	    //fprintf(fp,"%c",(unsigned char)(long)((a->car)->car));
	    //fprintf(fp,"%c",(unsigned char)(long)((a->car)->cdr));
	    *s++ = (unsigned char)(long)((a->car)->car);
	    *s++ = (unsigned char)(long)((a->car)->cdr);
	}
	a = a->cdr;
    }
    *s = '\0';
    return;
    //puts("予期せぬエラーです。終了します。");
    //exit(1);
}

// end of file

