; linux.lsp

; n: utf-8の第1バイト、返し値: その文字のバイト数
(defun byte-utf-8 (n)
    (cond
	((not (integerp n)) nil)
	((and (<= 0 n) (<= n 127)) 1)
	((and (<= 194 n) (<= n 223)) 2)
	((and (<= 224 n) (<= n 239)) 3)
	((and (<= 240 n) (<= n 247)) 4)
	((and (<= 248 n) (<= n 251)) 5)
	((and (<= 252 n) (<= n 253)) 6)
	(t nil) ) )

; str: utf-8文字列、head:取り出し開始位置、next-head:取り出し終了位置+1
(defun jsubseq (str head next-head)
    (let ((buf (coerce str 'list)) (n) (m (- next-head head)))
      (if
	(loop
	    (if (null buf) (return nil))
	    (if (zerop head) (return t))
	    (setq head (1- head))
	    (setq n (byte-utf-8 (char-code (car buf))))
	    (if (null n) (return nil))
	    (if (loop
		    (if (= n 0) (return t))
		    (setq n (1- n))
		    (if (null buf) (return nil))
		    (setq buf (cdr buf)) )
		t
		(return nil) ) )
	(jsubseq2 buf m)
	nil ) ) )

(defun jsubseq2 (buf head)
    (let ((n) (sub nil))
      (if
	(loop
	    (if (null buf) (return t))
	    (if (zerop head) (return t))
	    (setq head (1- head))
	    (setq n (byte-utf-8 (char-code (car buf))))
	    (if (null n) (return nil))
	    (if (loop
		    (if (= n 0) (return t))
		    (setq n (1- n))
		    (if (null buf) (return nil))
		    (setq sub (append sub (list (car buf))))
		    (setq buf (cdr buf)) )
		t
		(return nil) ) )
	(coerce sub 'string)
	nil ) ) )

; utf-8文字列strの長さを返す
(defun jlength (str)
    (let ((buf (coerce str 'list)) (n) (ct 0))
	(loop
	    (if (null buf) (return ct))
	    (setq n (byte-utf-8 (char-code (car buf))))
	    (if (null n) (return nil))
	    (setq ct (1+ ct))
	    (if (loop
		    (if (= n 0) (return t))
		    (setq n (1- n))
		    (if (null buf) (return nil))
		    (setq buf (cdr buf)) )
		t
		(return nil) ) ) ) )


