; Telephone Book S&S

(load "oop.lsp")

(defclass ctel-book)

(defmethod setup ((obj ctel-book)) )

(defmethod run ((obj ctel-book))
    (let ((part (make-instanse 'cpart)) (num))
	(tell part 'init-tel-table)
	(loop
	    (tell part 'disp-msg)
	    (setq num (read))
	    (case num
		(1 (tell part 'disp))
		(2 (tell part 'input))
		(3 (tell part 'erase))
		(4 (tell part 'write))
		(9 (return t)) ) ) ) )

(defclass cpart)

(defmethod disp-msg ((obj cpart))
    (princ "1:表示") (terpri)
    (princ "2:入力") (terpri)
    (princ "3:削除") (terpri)
    (princ "4:ファイルへ出力") (terpri)
    (princ "9:終了") (terpri) )

(defmethod init-tel-table ((obj cpart))
    (let ((h (make-hash-table)) (f) (d))
	(tell obj 'write-tel-table h)
	(setq f (open "teldata.txt"))
	(cond
	    ((null f) nil)
	    (t
	     (loop
		(setq d (read f nil t))
		(if (eql d t) (progn (close f) (return)))
		(setf (gethash (car d) h) (car (cdr d))) ) ) ) ) )

(defmethod write-tel-table ((obj cpart) htable) (setf (gethash 'tel-table obj) htable))

(defmethod read-tel-table ((obj cpart)) (gethash 'tel-table obj))

(defmethod input ((obj cpart))
    (let ((name) (number))
	(princ '名前を入力して下さい：)
	(setq name (read))
	(princ '電話番号を入力して下さい：)
	(setq number (read-line))
	(setf (gethash name (tell obj 'read-tel-table)) number) ) )

(defmethod disp ((obj cpart))
    (maphash #'(lambda (key value) (princ key) (spaces 1) (princ value) (terpri)) (tell obj 'read-tel-table)) )

(defmethod erase ((obj cpart))
    (let ((name) (number))
	(princ '削除するデータの名前を入力して下さい：)
	(setq name (read))
	(remhash name (tell obj 'read-tel-table)) ) )

(defmethod write ((obj cpart))
    (let ((f (open "teldata.txt" :direction :output)))
	(cond
	    ((null f) nil)
	    (t (maphash (lambda (key value) (print (list key value) f)) (tell obj 'read-tel-table)) (close f)) ) ) )

(setq tel-book (make-instanse 'ctel-book))
(tell tel-book 'setup)
(tell tel-book 'run)
